﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using Microsoft.Win32;  // Registry

namespace PythonIDE {
    public class Basis {

        public static String getNumber(String sValue) {
            int posi = sValue.IndexOf(" ");
            if (posi != -1) {
                return sValue.Substring(0, posi);
            }
            else {
                return sValue;
            }
        }

        /// <summary>
        /// return the line of the editor
        /// </summary>
        /// <param name="row"></param>
        /// <param name="text"></param>
        /// <returns></returns>
        public static String getLine(int row, String text) {
            StringBuilder sb = new StringBuilder();
            string[] splitStrings = { "\r\n" };
            string[] lines = text.Split(splitStrings, StringSplitOptions.None);
            if (row > 0 && row <= lines.Length) {
                return lines[row - 1];
            }
            else {
                return "Fehler in Modul getLine";
            }
        }

        /// <summary>
        /// return the linenumber of the text, text from 0 to index
        /// </summary>
        /// <param name="rowindex"></param>
        /// <param name="text"></param>
        /// <returns></returns>
        public static int getLinenr(int rowindex, String text) {
            StringBuilder sb = new StringBuilder();
            string[] splitStrings = { "\r\n" };  // { "\r", "\r\n", "\n" };
            string[] lines = text.Split(splitStrings, StringSplitOptions.None);
            int rowChars = 0;
            for (int i = 0; i < lines.Length - 1; i++) {
                String sLine = lines[i];
                if (rowindex < rowChars) {
                    return i;
                }
                rowChars += lines[i].Length + 2;
            }
            return lines.Length;
        }

        /// <summary>
        /// return only the name and the extention, test.txt
        /// </summary>
        /// <param name="sPathFilename"></param>
        /// <returns></returns>
        public static String getFilename(String sPathFilename) {
            int k = sPathFilename.LastIndexOf('\\');
            if (k >= 0) {
                return sPathFilename.Substring(k + 1);
            }
            else {
                return sPathFilename;
            }
        }  // getFilename

        /// <summary>
        /// return only the extention, sample: test.TXT return txt
        /// </summary>
        /// <param name="sPathFilename"></param>
        /// <returns></returns>
        public static String getFilenameExt(String sPathFilename) {
            int k = sPathFilename.LastIndexOf('.');
            if (k >= 0) {
                return sPathFilename.Substring(k + 1).ToLower();
            }
            else {
                return "";
            }
        }  // getFilename

        /// <summary>
        /// return the Path of a file
        /// </summary>
        /// <param name="sPathFilename"></param>
        /// <returns></returns>
        public static String getPath(String sPathFilename) {
            int k = sPathFilename.LastIndexOf('\\');
            if (k >= 0) {
                return sPathFilename.Substring(0, k);
            }
            else {
                return "";
            }
        }  // getPath

        /// <summary>
        /// return the last directory of a file
        /// </summary>
        /// <param name="sPath"></param>
        /// <returns></returns>
        public static String getLastPath(String sPath) {
            if (sPath.Length <= 3) {
                return sPath;
            }

            if (sPath.EndsWith("\\")) {
                sPath = sPath.Substring(0, sPath.Length - 1);
            }
            int k = sPath.LastIndexOf('\\');
            if (k >= 0) {
                return sPath.Substring(k + 1, sPath.Length - k - 1);
            }
            else {
                return "";
            }
        }  // getPath


        /// <summary>
        /// replace the extention from sPathFilename to sExt; c:\daten\1.xhtml , css ==> c:\c:\daten\1.css
        /// </summary>
        /// <param name="sPathFilename"></param>
        /// <param name="sExt"></param>
        /// <returns></returns>
        public static String changeFilenameExt(String sPathFilename, string sExt) {
            int k = sPathFilename.LastIndexOf('.');
            if (k >= 0) {
                return sPathFilename.Substring(0, k + 1) + sExt;  // k+1 fuer Punkt
            }
            else {
                return sPathFilename;
            }
        }  // getFilename


        public static DialogResult readYesNoCancel(string message, string title) {
            return MessageBox.Show(message, title, MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);   // Exclamation
        }

        public static bool readYesNo(string message, string title) {
            return MessageBox.Show(message, title, MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes;
        }





        public static String ReadRegString(string root, string KeyName) {
            string sKey;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return "";
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        sKey = "";
                    else {
                        sKey = regist.GetValue(KeyName).ToString();
                    }
                    return sKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Writing registry " + KeyName.ToUpper());
                return "";
            }
        }  // readRegString


        public static long ReadRegLong(string root, string KeyName) {
            long lKey;
            string sKey;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return 0;
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        lKey = 0;
                    else {
                        sKey = regist.GetValue(KeyName).ToString();
                        lKey = (long)Convert.ToUInt64(sKey);
                    }
                    return lKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Reading registry long" + KeyName.ToUpper());
                return 0;
            }
        }  // readRegLong


        public static int ReadRegInt(string root, string KeyName) {
            int lKey;
            string sKey;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return 0;
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        lKey = 0;
                    else {
                        sKey = regist.GetValue(KeyName).ToString();
                        lKey = (int)Convert.ToInt32(sKey);
                        //.ToUInt64(sKey);
                    }
                    return lKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Reading registry int" + KeyName.ToUpper());
                return 0;
            }
        }  // readRegInt

        public static ulong ReadRegULong(string root, string KeyName) {
            string sKey;
            ulong lKey = 0;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return 0;
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        lKey = 0;
                    else {
                        sKey = regist.GetValue(KeyName).ToString();
                        lKey = Convert.ToUInt64(sKey);
                    }
                    return lKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Reading registry double" + KeyName.ToUpper());
                return 0;
            }
        }  // readRegLong


        public static double ReadRegDouble(string root, string KeyName) {
            string sKey;
            double dKey = 0;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return 0.0;
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        dKey = 0.0;
                    else {
                        sKey = regist.GetValue(KeyName).ToString();
                        dKey = Convert.ToDouble(sKey);
                    }
                    return dKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Reading registry double" + KeyName.ToUpper());
                return 0.0;
            }
        }  // readRegDouble



        // WriteWriteWriteWriteWriteWriteWriteWriteWriteWriteWriteWrite


        public static bool WriteRegString(string root, string KeyName, string Value) {
            try {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    rKey.SetValue(KeyName, Value, RegistryValueKind.String);
                    return true;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Writing registry string" + KeyName.ToUpper());
                return false;
            }
        }



        public static bool WriteRegULong(string root, string KeyName, ulong Value) {
            try {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    rKey.SetValue(KeyName, Value, RegistryValueKind.DWord);
                    return true;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Writing registry long" + KeyName.ToUpper());
                return false;
            }
        }

        // fuer long int etc
        public static bool WriteRegInt(string root, string KeyName, int Value) {
            try {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    rKey.SetValue(KeyName, Value, RegistryValueKind.DWord);
                    return true;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Writing registry int" + KeyName.ToUpper());
                return false;
            }
        }



        public static bool WriteRegDouble(string root, string KeyName, double Value) {
            try {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    rKey.SetValue(KeyName, Value.ToString(), RegistryValueKind.String);
                    return true;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Writing registry double" + KeyName.ToUpper());
                return false;
            }
        }

        public static bool ReadRegBool(string root, string KeyName) {
            bool bKey;
            RegistryKey regist;
            try {
                regist = Registry.CurrentUser.OpenSubKey(root);
                if (regist == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    if (regist.GetValue(KeyName) == null)
                        bKey = false;
                    else {
                        int value = (int)regist.GetValue(KeyName);
                        bKey = value == 1;
                    }
                    return bKey;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Reading registry bool" + KeyName.ToUpper());
                return false;
            }
        }  // readRegBool

        public static bool WriteRegBool(string root, string KeyName, bool Value) {
            try {
                RegistryKey rKey = Registry.CurrentUser.CreateSubKey(root);
                if (rKey == null) {
                    //MessageBox.Show("Fehler", "Registry-Eintrag ist nicht vorhanden: " + KeyName.ToUpper());
                    return false;
                }
                else {
                    if (Value)
                        rKey.SetValue(KeyName, 1, RegistryValueKind.DWord);  // Bool geht nicht                    
                    else
                        rKey.SetValue(KeyName, 0, RegistryValueKind.DWord);  // Bool geht nicht                    
                    return true;
                }
            }
            catch (Exception e) {
                // OOOOH, an Error
                MessageBox.Show(e.ToString(), "Writing registry bool" + KeyName.ToUpper());
                return false;
            }
        }

        public static String IHex4(int i) {
            String s = Convert.ToString(i, 16);
            while (s.Length < 4) {
                s = "0" + s;
            }
            return "0x" + s.ToUpper();
        }

        public static void Error(String text, String caption) {
            MessageBox.Show(text, caption, MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

    }
}
